import vp

from Application  import Application
from Window       import Window
from Canvas       import Canvas
from Box          import Box
from Frame        import Frame
from RadioGroup   import RadioGroup
from WidgetButton import PushButton, ToggleButton


def test():
	app = Application('test')
	win = Window({ 'size': (300, 300) })

	view = Canvas()
	win.AddWorkArea( view )

	rg1 = RadioGroup()
	
	view.AddChild( Box({
	    'pos'       : (10, 10),
		'alignment' : vp.HCENTER, 
		'child_list': [
		    ToggleButton({
			    'name'         :'Roman', 
				'radio_group'  : rg1,
				'use_indicator': vp.FALSE
			    }),
			ToggleButton({
			    'name'         :'Italic', 
				'radio_group'  : rg1,
		        'use_indicator': vp.FALSE
			    }),
			ToggleButton({
				'name'         :'Bold', 
				'radio_group'  : rg1,
		        'use_indicator': vp.FALSE
			    })
		    ]
	    }))
	view.AddChild( Box({
	    'pos'       : (10, 100),
		'alignment' : vp.VCENTER, 
		'child_list': [
		    ToggleButton({ 'name':'Roman', 'use_indicator': vp.FALSE }),
		    ToggleButton({ 'name':'Italic','use_indicator': vp.FALSE }),
			ToggleButton({ 'name':'Bold', 'use_indicator': vp.FALSE })
		    ]
	    }))
	view.AddChild( Box({
		'pos'       : (100, 100),
		'alignment' : vp.VCENTER, 
		'child_list': [
	        PushButton({'name': 'Roman'}),
			PushButton({'name': 'Italic'}),
			PushButton({'name': 'Bold'})
			] 
	    }))

	rg2 = RadioGroup()
	view.AddChild( Frame({
		'pos'   : (10, 200),
		'label' : 'Font style', 
		'child' : Box({
		    'child_list': [
		        ToggleButton({ 'name': 'Roman',  'radio_group': rg2 }),
				ToggleButton({ 'name': 'Italic', 'radio_group': rg2 }),
				ToggleButton({ 'name': 'Bold',   'radio_group': rg2 })
				]
			})
	    }))

	app.Run()


test()
